#coding=utf-8

#存放一些又碎又小不知道該放哪裡好的小玩意兒

import shutil, os, re, hashlib

from PyQt4.QtGui import *
from PyQt4.QtCore import *

from lonote.version import version
import lonote.path as path

def copy(src,dst):
    def direxist(path):
        '''用這def跑過之後，路徑的dir會全部存在'''
        if os.path.isdir(path):
            return
        else:
            direxist(os.path.dirname(path))
            os.mkdir(path)
    dirpath = os.path.dirname(dst)
    direxist(dirpath)
    shutil.copy2(src, dst)

def getSha224(string):
    '''解算string的sha224並回傳'''
    return hashlib.sha224(string.encode('utf-8')).hexdigest()


def rgbToHTMLColor(rgb):
    ''' 把rgb tuple 轉換成 #RRGGBB
    這是從網路上找的，很神奇的碼，不過短又有效'''
    hexcolor = '#%02x%02x%02x' % rgb
    return hexcolor


def infoDialog(title,text,logoFile):
    '''把QMessage簡單包裝起來'''
    msgBox = QMessageBox(
            title,
            text,
            QMessageBox.Question,
            QMessageBox.Ok ,QMessageBox.NoButton ,QMessageBox.NoButton
            )
    msgBox.setIconPixmap(QPixmap(logoFile))
    msgBox.exec()


def questionDialog(title,text,logoFile):
    '''把QMessage簡單包裝起來'''
    msgBox = QMessageBox(
            title,
            text,
            QMessageBox.Information,
            QMessageBox.Yes ,QMessageBox.No ,QMessageBox.NoButton
            )
    msgBox.setIconPixmap(QPixmap(logoFile))
    if msgBox.exec() == QMessageBox.Yes:
        return True
    else:
        return False

def isSupportImage(path):
    '''檢查副檔名看看是否是支援的圖檔'''
    valid = ['.png', '.gif', '.jpg', '.jpeg', '.svg', '.bmp']
    base,ext = os.path.splitext(path)
    if ext in valid:
        return True
    else:
        return False


#控制圖片大小的必殺js字段，非常脆弱，即使是換行與空格也可能破壞她，除非你非常確定自己在幹嘛，否則最好別碰她
#功能：1.預設插入最大圖片為橫寬{$PIC_WIDTH}，超過會被縮減到{$PIC_WIDTH}(小於則不變更)
#      2.可用滾輪縮放，滾一格增(減)10%大小
#      3.在圖上按鈕後，圖片尺寸會重設為100%
#      4.如果lonoteImgResizeEnable = false，兩種縮放功能都會失效（預設true）
#imgSizeControlJS = '''lonoteImgResizeEnable=true; function defsizepic{$PIC_WIDTH}(pic){if(Boolean({$PIC_WIDTH})){if(pic.width>{$PIC_WIDTH})pic.width={$PIC_WIDTH};}}function resizepic(pic){if(lonoteImgResizeEnable){if(pic.style.zoom!=100)pic.style.zoom="100%";}} function bbimg(pic){if (lonoteImgResizeEnable){var zoom=parseInt(pic.style.zoom, 10)||100;zoom+=event.wheelDelta/12;if (zoom>0) pic.style.zoom=zoom+"%";return false;}}'''

#imgInsertString = '<script language="JavaScript">'+ imgSizeControlJS + '</script>' + '''<img onmousewheel="return bbimg(this)" src="{$FILEPATH}" onload="javascript:defsizepic{$PIC_WIDTH}(this)" onclick="javascript:resizepic(this)" border="0">'''

JS_imgSizeControl = '''\
//lonoteImgResizeEnable=true;

//用defaultwidth恢復圖片大小
function setDefaultSize(){
    if(lonoteImgResizeEnable){
        if (this.hasAttribute("defaultwidth")){
            this.width = parseInt(this.getAttribute("defaultwidth"), 10);
            return false;
        }
        //向前相容用
        else if(this.style.zoom != 100){
            this.style.zoom = "100%";
            return false;
        }
    }
}

function mouseWheelResize(){
    if (lonoteImgResizeEnable){
        //defaultwidth是我自己加入的屬性
        if (this.hasAttribute("defaultwidth")){
            //放大量為每格10%的defaultwidth
            var width = this.width;
            var scale = parseInt(this.getAttribute("defaultwidth"), 10)/10;
            width += event.wheelDelta * scale / 120;
            if (width > 0){
                this.width = width;
            }
            return false;
        }
        //向前相容用
        else{
            var zoom = parseInt(this.style.zoom, 10) || 100;
            zoom += event.wheelDelta/12;
            if (zoom > 0){
                this.style.zoom = zoom + "%";
            }
            return false;
        }
    }
}

imgs = document.getElementsByTagName("img");
for(var i=0;i<imgs.length;i++){
    imgs[i].onclick = setDefaultSize;
    imgs[i].onmousewheel = mouseWheelResize;
}
'''

#移除當前選擇區域的格式：
#如果沒有選擇，則移除游標所在位置外側的Tag。
JS_removeTag = '''\
function rmformat(){
    if (getSelection().toString() == ""){
        var container = getSelection().anchorNode.parentNode;
        //container = container.nodeType == 3 ? container.parentNode : container;
        if (container.localName != "body" && 
            container.localName != "div" && 
            container.localName != "li"){
            //記錄位置
            var r = window.getSelection().getRangeAt();
            var offset = r.startOffset;

            var pNode = container.parentNode;
            var iNode = container.firstChild;
            //套換內容
            pNode.insertBefore(iNode, container);
            //container.outerHTML = container.innerHTML;

            var range = document.createRange();
            var sel = window.getSelection();
            range.setStart(iNode, offset);
            range.collapse(true);
            pNode.normalize(); //合併節點，否則多次操作時會錯誤。
            pNode.removeChild(container); //移除殘餘物
            sel.removeAllRanges();
            sel.addRange(range);
        }
    }
    else{
        document.execCommand("RemoveFormat");
    }
}
rmformat()'''

#JS_addTag = '''\
#function addTag(){
#    alert(window.getSelection().getRangeAt());
#    var range = document.createRange();
#    var newNode = document.createElement("i");
#    range.selectNode(document.getElementsByTagName("div").item(0));
#    range.surroundContents(newNode);
#    //newNode = document.createElement("b");
#    //newNode.appendChild(range.extractContents());
#    //sel = window.getSelection().getRangeAt().surroundContents();
#    //document.execCommand("insertHTML", false, "<b>" + sel + "</b>");
#}
#addTag();
#'''

JS_scrollToHeading = '''\
function getElementsByTagNames(list,obj) {
    if (!obj) var obj = document;
        var tagNames = list.split(',');
    var resultArray = new Array();
    for (var i=0;i<tagNames.length;i++) {
        var tags = obj.getElementsByTagName(tagNames[i]);
        for (var j=0;j<tags.length;j++) {
            resultArray.push(tags[j]);
        }
    }
    var testNode = resultArray[0];
    if (!testNode) return [];
    if (testNode.sourceIndex) {
        resultArray.sort(function (a,b) {
            return a.sourceIndex - b.sourceIndex;
        });
    }
    else if (testNode.compareDocumentPosition) {
        resultArray.sort(function (a,b) {
            return 3 - (a.compareDocumentPosition(b) & 6);
        });
    }
    return resultArray;
}

function findPosY(obj) {
    var curtop = 0;
    while(obj.offsetParent) {
        curtop += obj.offsetTop;
        obj = obj.offsetParent;
        }
    return curtop;
}

function scrollToAnimation(targetPos, dur) {
    var startTime = (new Date).getTime();
    var endTime = startTime + dur;
    var pageYOffset = window.pageYOffset;
    var needToMove = targetPos - pageYOffset;
    var currentTime = (new Date).getTime();
    stepMove = function() {
        currentTime = (new Date).getTime();
        stepTarget = (((currentTime - startTime) / dur) * needToMove) + pageYOffset;
        window.scrollTo(0,stepTarget)
        }
    id = window.setInterval(stepMove,10);
    window.setTimeout(window.clearInterval, dur, id);
    return window.setTimeout(window.scrollTo, dur, 0, targetPos);
}

scrollToHeading = function(anchorName ,index) {
    if (!index){
        index = 0;
    }

    var children = getElementsByTagNames("h1,h2,h3,h4,h5,h6");

    for (var i = 0; i < children.length; i++) {
        var heading = children[i].innerHTML;

        // Remove all HTML tags
        while (heading.indexOf("<") >= 0) {
            heading = heading.substring(0, heading.indexOf("<")) + heading.substring(heading.indexOf(">") + 1);
        }

        if (heading == anchorName) {
            if (index == 0) {
                var y = findPosY(children[i]);
                return scrollToAnimation(y, 200)
                //window.scrollTo(0,y);
                return true;
            }
            else {
                --index;
            }
        }
    }
    return false;
};
scrollToHeading("{$TITLE}",{$INDEX});'''

#變更Caret位置
JS_setCaretPosByMousePos = '''\
function focusEle(x,y){
var ele = document.elementFromPoint(x,y);
var range = document.createRange();
range.setStartAfter(ele);
var sel = window.getSelection();
sel.removeAllRanges();
sel.addRange(range);
}
focusEle({$POSX},{$POSY});'''


#HTML大量匯出時用的內容
CSS_HTMLMultiExport = '''\
html, body, div, iframe { margin:0px; padding: 0px; height: 100%; }
iframe { display: block; width: 100%; border: none; }

body{
margin: auto;
margin-left:auto;
margin-right:auto;
width:95%;
}

aside#nav{
padding:0px 0px 0px 0px;
margin: 5px;
background:#efefef;
border:#CCCCCC 1px solid;
border-radius:3px;
-moz-border-radius:3px;
-khtml-border-radius:3px;
width:20%;
max-width: 250px;
float:left;
height:95%;
}

iframe#nav{
border:#CCCCCC 1px none;
border-radius:3px;
-moz-border-radius:3px;
-khtml-border-radius:3px;
width:100%;
height: 100%;
}

div#main{
height:95%;
}

iframe#main{
padding: 15px;
margin: 10px;
background:#f8f8f8;
border:#CCCCCC 1px solid;
border-radius:3px;
-moz-border-radius:3px;
-khtml-border-radius:3px;
width: 70%;
height: 95%;
}
'''

#定義html分行用的正則表達式
#第一個|之前匹配</br><br><br\>的各種變體
#再來匹配</p>的各種變體
#再來匹配</h1>~</h6>的各種變體
#再來匹配水平線<Hr/>的各種變體
#再來是</blockquote>的變體
#再來是</pre>
#再來是</address>
#再來是</code>
#再來是</head>
#再來是</li>(有序與無序列表項目)
#再來是</dt>(自定義列表表頭)
#再來是</dd>(自定義列表內容)
#最後兩點是指要匹配到後面兩個字元不是換行符的（後面沒有接兩個換行符，意味需要額外處理，已經接好就不用了，但那個匹配要保留不能刪除）
re_splitlinesPattern = re.compile(r'(<\s*/?\s*[bB][rB]\s*/?\s*>|<\s*/\s*[pP]\s*>|<\s*/[hH][1-6]\s*>|<\s*[hH][rR]\s*/?\s*>|<\s*/\s*[bB][lL][oO][cC][kK][qQ][uU][oO][tT][eE]\s*>|<\s*/\s*[pP][rR][eE]\s*>|<\s*/\s*[aA][dD][dD][rR][eE][sS][sS]\s*>|<\s*/\s*[cC][oO][dD][eE]\s*>|<\s*/\s*[hH][eE][aA][dD]\s*>|<\s*/\s*[lL][iI]\s*>|<\s*/\s*[dD][tT]\s*>|<\s*/\s*[dD][dD]\s*>)(..)')

#info

dataFmt = {
        '$VERSION': version,
        '$ICON': path.icons.about,
        '$DESIGNER_NAME': '林雪凡=larina',
        '$DESIGNER_BLOGGER': 'http://wfst.blogspot.com',
        '$DESIGNER_MAIL': 'larina.wf@gmail.com',
        '$MANUAL_PAGE': 'http://code.google.com/p/lonote/wiki/Manual',
        '$PROJECT_SITE': 'http://code.google.com/p/lonote/',
        '$FORUM_SITE': 'https://groups.google.com/forum/#!forum/lonote',
        '$KEEPNOTE_SITE': 'http://keepnote.org/',
        '$LICENSE_PAGE': 'http://www.gnu.org/licenses/gpl.html'}

#點F1會冒出來的Help內容
LoNoteInfo = _('''\
        <img src='{$ICON}' height=128 align=right style ='float:right'>
        <span style="font-size: xx-large;"><b>LoNote</b></span><span style="font-size: small;"> <sub><i>Ver. {$VERSION}</i></sub></span><hr width='90%'><br>
        <span style="font-size: small;"><i>designer：<b>{$DESIGNER_NAME} （<a href="{$DESIGNER_BLOGGER}">blog</a>）</b></i></span><br>
        <span style="font-size: small;"><i>mail: <b><a href='mailto:{$DESIGNER_MAIL}'>{$DESIGNER_MAIL}</a></b></i></span><br>
        <br>
        LoNote is a Free Software, suitable for personal note-taking.<br>
        <br>
        If you have some using problems. Here is <a href='{$MANUAL_PAGE}'>Manual</a>. On the other hand, you can also visit <a href="{$PROJECT_SITE}">The LoNote Project</a> to look up developing status, or <a href="{$FORUM_SITE}">sharing your opinion</a>.<br>
        <br>
        Initially, I designed this program for writing novels. I hope you like it so.<br>
        LoNote inherit <a href='{$KEEPNOTE_SITE}'>keepnote</a>'s design philosophy. Thanks for every forerunner.<br>
        <br>
        This program release by <a href='{$LICENSE_PAGE}'>GNU GPLv3 License</a>.''').format(**dataFmt)
